import 'package:m4e_sdk/m4e_sdk.dart';

class AuthService {
  final M4eAuthService _m4eAuthService = M4eAuthService();
  final M4eUserService _m4eUserService = M4eUserService();

  Future<M4eUniqueId> signInWithPhoneNumber(
      M4eAuthPhoneNumberForm m4eAuthPhoneNumberForm) async {
    try {
      final _uniqueId =
          await _m4eAuthService.verifyPhoneNumber(m4eAuthPhoneNumberForm);

      print(_uniqueId.toString());

      return _uniqueId;
    } on M4eServerException catch (e) {
      throw e;
    }
  }

  Future<M4eAuthToken> verifyOTPCode(
      M4eAuthOTPVerificationForm otpVerificationForm) async {
    try {
      final _authToken =
          await _m4eAuthService.verifyOTPCode(otpVerificationForm);

      return _authToken;
    } on M4eException catch (e) {
      throw e;
    }
  }

  Future<M4eUser> getAuthenticatedUserAccount() async {
    try {
      final _m4eUser = await _m4eUserService.getM4eUser();

      return _m4eUser;
    } on M4eException catch (e) {
      throw e;
    }
  }

  Future<M4eUniqueId> createUserAccount(M4eUserForm m4eUserForm) async {
    try {
      final _m4eUniqueId = await _m4eUserService.createM4eUser(m4eUserForm);

      return _m4eUniqueId;
    } on M4eException catch (e) {
      throw e;
    }
  }
}
