import 'package:m4e_sdk/m4e_sdk.dart';

class WalletService {
  final M4eWalletService _m4eWalletService = M4eWalletService();

  Future<M4eBalance> getWalletBalance(M4eUniqueId walletId) async {
    try {
      final _balance = await _m4eWalletService.getWalletBalance(walletId);

      return _balance;
    } on M4eServerException catch (e) {
      throw e;
    }
  }

  Future<M4eWalletList> getWallets(M4eUniqueId userId) async {
    try {
      final _wallets =
          await _m4eWalletService.getWallets(currentUserId: userId);

      return _wallets;
    } on M4eServerException catch (e) {
      throw e;
    }
  }

  Future<M4eUniqueId> createWallet(
      M4eUniqueId userId, M4eWalletForm m4eWalletForm) async {
    try {
      final _walletId =
          await _m4eWalletService.createWallet(userId, m4eWalletForm);

      return _walletId;
    } on M4eServerException catch (e) {
      throw e;
    }
  }
}
