import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../../core/core.dart';
import '../../models/models.dart';

class M4ePermissionForm extends Equatable {
  final M4eUniqueId subId;
  final M4eUniqueId objId;
  final M4eAccessPermissionType type;
  final List<M4eAccessPermissionSet> encoding;

  const M4ePermissionForm({
    @required this.subId,
    @required this.objId,
    @required this.type,
    @required this.encoding,
  });

  Map<String, dynamic> toJson() {
    return {
      'subId': this.subId.toString(),
      'objId': this.objId.toString(),
      'accessEncoding': {
        'type': this.type.toString(),
        'encoding': encoding?.map((e) => e.toString())?.toList() ?? []
      }
    };
  }

  @override
  List<Object> get props => [subId, objId, type, encoding];

  @override
  String toString() {
    return 'M4ePermissionForm(subId: $subId, objId: $objId, type: $type, encoding: ${encoding.toString()})';
  }
}
