import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

import '../models.dart';
import '../../m4e_forms/m4e_forms.dart';
import '../../core/core.dart';

part 'reciepient_wallet.freezed.dart';

@freezed
abstract class M4eReciepientWallet with _$M4eReciepientWallet {
  const factory M4eReciepientWallet.m4eWalletProvider(
      {@required M4eWallet wallet}) = M4eWalletProvider;
  const factory M4eReciepientWallet.mobileMoneyWalletProvider({
    @required M4eNetworkProviderType provider,
    @required M4ePhoneNumber phoneNumber,
  }) = MobileMoneyWalletProvider;
}

extension MobileMoneyWalletProviderXtension on MobileMoneyWalletProvider {
  M4eWalletForm toWalletForm({
    @required M4eUniqueId walletId,
    @required String label,
    @required M4eCurrencyType currencyType,
  }) {
    assert(walletId != null,
        'MobileMoneyWalletProvider [walletId] should not be null');
    assert(
        label != null, 'MobileMoneyWalletProvider [label] should not be null');
    assert(currencyType != null,
        'MobileMoneyWalletProvider [currencyType] should not be null');

    return M4eWalletForm(
      id: walletId,
      label: label,
      currency: currencyType,
      type: M4eWalletType.MOBILE_MONEY,
      detail: M4eWalletDetailType.mobileMoneyWalletDetail(
        provider: this.provider,
        phoneNumber: this.phoneNumber,
      ),
    );
  }
}
