import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

import '../../core/core.dart';
import '../../models/models.dart';

part 'wallet_detail.freezed.dart';

@freezed
abstract class M4eWalletDetailType implements _$M4eWalletDetailType {
  const M4eWalletDetailType._();

  static M4eWalletDetailType fromJson(Map<String, dynamic> json) {
    // TODO: bad code refactor
    if (json == null) return null;

    if (!json.containsKey('provider')) {
      return M4eWalletDetailType.m4eWalletDetail(
          id: M4eUniqueId.fromUniqueString(json['id']));
    } else {
      // TODO: account for other provider cases here (eg. banks etc) using [provider]
      return M4eWalletDetailType.mobileMoneyWalletDetail(
        provider: M4eNetworkProviderType.parse(json['provider']),
        phoneNumber: M4ePhoneNumber.fromJson(json['phone']),
      );
    }
  }

  const factory M4eWalletDetailType.m4eWalletDetail(
      {@required M4eUniqueId id}) = M4eWalletDetail;

  const factory M4eWalletDetailType.mobileMoneyWalletDetail({
    @required M4eNetworkProviderType provider,
    @required M4ePhoneNumber phoneNumber,
  }) = MobileMoneyWalletDetail;
}

extension M4eWalletDetailXtension on M4eWalletDetail {
  Map<String, dynamic> toJson() {
    return {
      'id': this.id.toString(),
    };
  }
}

extension MobileMoneyWalletDetailXtension on MobileMoneyWalletDetail {
  Map<String, dynamic> toJson() {
    return {
      'provider': this.provider.toString(),
      'phone': this.phoneNumber.toJson(),
    };
  }
}
